package ;

import openfl.Lib;
import openfl.display.Sprite;
import openfl.events.Event;
import openfl.events.MouseEvent;

/**
 * ...
 * @author Orava
 */

class Main extends Sprite {
	var inited:Bool;

	var mapgen:PlanetGenerator;

	/* ENTRY POINT */

	function resize(e) {
		if (!inited) init();
		// else (resize or orientation change)
	}

	function init() {
		if (inited) return;
		inited = true;

		// (your code here)

		// Stage:
		// stage.stageWidth x stage.stageHeight @ stage.dpiScale

		// Assets:
		// nme.Assets.getBitmapData("img/assetname.jpg");
	}

	/* SETUP */

	public function new() {
		super();
		addEventListener(Event.ADDED_TO_STAGE, added);
	}

	function added(e) {
		removeEventListener(Event.ADDED_TO_STAGE, added);

		initMapGen();
	}

	function initMapGen() {

		mapgen = new PlanetGenerator();

		mapgen.x=stage.stageWidth  * 0.5;
		mapgen.y=stage.stageHeight * 0.5;

		mapgen.roll();

		addChild(mapgen);

		stage.addEventListener(MouseEvent.MOUSE_UP, click);
	}

	private function randomParams():Void {

		mapgen.SEED = Std.int(Math.random()* 9000);

		mapgen.cloudDensity 	=0.01 * (1 + (Math.random()* 9 							));
		mapgen.debrisDensity 	=0.01 * (1 + (Math.random()* Math.random()* 50 			));
		mapgen.debrisGap 		=0.01 * (1 + (Math.random()* Math.random()* 100 		));
		mapgen.debrisField 		=0.01 * (1 + (Math.random()* 100 						));
		mapgen.lightRadius 		=0.01 * (50+ (Math.random()* 150 						));
		mapgen.lightMinimum 	=0.01 * (1 + (Math.random()* 50 						));
		mapgen.lightIntensity 	=0.01 * (50 + (Math.random()* 150 						));
		mapgen.atmosIntensity 	=0.01 * (1 + (Math.random()* 70 						));
		mapgen.atmosRadius 		=0.01 * (1 + (110 + Math.random()* Math.random()* 90	));

	}

	private function click(e:MouseEvent):Void {

		randomParams();
		mapgen.roll();
	}

	public static function main() {
		// static entry point
		Lib.current.stage.align = flash.display.StageAlign.TOP_LEFT;
		Lib.current.stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
		Lib.current.addChild(new Main());
	}
}
